diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/simulator.h ns-3.31/src/core/model/simulator.h
--- ns-3.30.1/src/core/model/simulator.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/simulator.h	2020-06-27 17:38:30.000000000 -0700
@@ -476,259 +262,38 @@
    * A context of 0xffffffff means no context is specified.
    * This method is thread-safe: it can be called from any thread.
    *
-   * @see Schedule(const Time&,MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
+   * We leverage SFINAE to discard this overload if the second argument is
+   * convertible to Ptr<EventImpl> or is a function pointer.
+   *
+   * @tparam FUNC @deduced Template type for the function to invoke.
+   * @tparam Ts @deduced Argument types.
    * @param [in] context User-specified context parameter
    * @param [in] delay The relative expiration time of the event.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
+   * @param [in] f The function to invoke.
+   * @param [in] args Arguments to pass to MakeEvent.
    */
-  template <typename MEM, typename OBJ>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj);
+  template <typename FUNC,
+            typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value,int>::type = 0,
+            typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,int>::type = 0,
+            typename... Ts>
+  static void ScheduleWithContext (uint32_t context, Time const &delay, FUNC f, Ts&&... args);
 
   /**
-   * @see ScheduleWithContext(uint32_t,const Time&,MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   */
-  template <typename MEM, typename OBJ, typename T1>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   */
-  template <typename MEM, typename OBJ, typename T1, typename T2>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @tparam T4 @deduced Type of fourth argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @param [in] a4 The fourth argument to pass to the invoked method
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3, T4 a4);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @tparam T4 @deduced Type of fourth argument.
-   * @tparam T5 @deduced Type of fifth argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @param [in] a4 The fourth argument to pass to the invoked method
-   * @param [in] a5 The fifth argument to pass to the invoked method
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4, typename T5>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, MEM mem_ptr, OBJ obj, 
-                                   T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
-
-  /**
-   * This method is thread-safe: it can be called from any thread.
-   *
-   * @param time the relative expiration time of the event.
-   * @param context user-specified context parameter
-   * @param mem_ptr member method pointer to invoke
-   * @param obj the object on which to invoke the member method
-   * @param a1 the first argument to pass to the invoked method
-   * @param a2 the second argument to pass to the invoked method
-   * @param a3 the third argument to pass to the invoked method
-   * @param a4 the fourth argument to pass to the invoked method
-   * @param a5 the fifth argument to pass to the invoked method
-   * @param a6 the sixth argument to pass to the invoked method
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-  static void ScheduleWithContext (uint32_t context, Time const &time, MEM mem_ptr, OBJ obj, 
-                                   T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
-  
-  /**
    * Schedule an event with the given context.
    * A context of 0xffffffff means no context is specified.
    * This method is thread-safe: it can be called from any thread.
    *
-   * When the event expires (when it becomes due to be run), the
-   * function will be invoked with any supplied arguments.
-   *
-   * This method is thread-safe: it can be called from any thread.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] f The function to invoke
-   */
-  static void ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(void));
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,(*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
+   * @tparam Us @deduced Formal function argument types.
+   * @tparam Ts @deduced Actual function argument types.
    * @param [in] context User-specified context parameter
    * @param [in] delay The relative expiration time of the event.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
+   * @param [in] f The function to invoke.
+   * @param [in] args Arguments to pass to the invoked function.
    */
-  template <typename U1,
-            typename T1>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1), T1 a1);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,(*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   */
-  template <typename U1, typename U2,
-            typename T1, typename T2>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2), T1 a1, T2 a2);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,(*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   */
-  template <typename U1, typename U2, typename U3,
-            typename T1, typename T2, typename T3>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2,U3), T1 a1, T2 a2, T3 a3);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,(*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam U4 @deduced Formal type of the fourth argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @tparam T4 @deduced Actual type of the fourth argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @param [in] a4 The fourth argument to pass to the function to invoke
-   */
-  template <typename U1, typename U2, typename U3, typename U4, 
-            typename T1, typename T2, typename T3, typename T4>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2,U3,U4), T1 a1, T2 a2, T3 a3, T4 a4);
-
-  /**
-   * @see ScheduleWithContext(uint32_t,const Time&,(*)())
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam U4 @deduced Formal type of the fourth argument to the function.
-   * @tparam U5 @deduced Formal type of the fifth argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @tparam T4 @deduced Actual type of the fourth argument.
-   * @tparam T5 @deduced Actual type of the fifth argument.
-   * @param [in] context User-specified context parameter
-   * @param [in] delay The relative expiration time of the event.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @param [in] a4 The fourth argument to pass to the function to invoke
-   * @param [in] a5 The fifth argument to pass to the function to invoke
-   */
-  template <typename U1, typename U2, typename U3, typename U4, typename U5,
-            typename T1, typename T2, typename T3, typename T4, typename T5>
-  static void ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(U1,U2,U3,U4,U5), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
-
-  /**
-   * This method is thread-safe: it can be called from any thread.
-   *
-   * @param time the relative expiration time of the event.
-   * @param context user-specified context parameter
-   * @param f the function to invoke
-   * @param a1 the first argument to pass to the function to invoke
-   * @param a2 the second argument to pass to the function to invoke
-   * @param a3 the third argument to pass to the function to invoke
-   * @param a4 the fourth argument to pass to the function to invoke
-   * @param a5 the fifth argument to pass to the function to invoke
-   * @param a6 the sixth argument to pass to the function to invoke
-   */
-  template <typename U1, typename U2, typename U3, typename U4, typename U5, typename U6,
-            typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-  static void ScheduleWithContext (uint32_t context, Time const &time, void (*f)(U1,U2,U3,U4,U5,U6), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
-
+  template <typename... Us, typename... Ts>
+  static void ScheduleWithContext (uint32_t context, Time const &delay, void (*f)(Us...), Ts&&... args);
   /** @} */  // Schedule events (in a different context) to run now or at a future time.
-  
+
   /**
    * @name Schedule events (in the same context) to run now.
    */
@@ -736,237 +301,36 @@
   /**
    * Schedule an event to expire Now. All events scheduled to
    * to expire "Now" are scheduled FIFO, after all normal events
-   * have expired. 
+   * have expired.
    *
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ>
-  static EventId ScheduleNow (MEM mem_ptr, OBJ obj);
-
-  /**
-   * @see ScheduleNow(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1>
-  static EventId ScheduleNow (MEM mem_ptr, OBJ obj, T1 a1);
-
-  /**
-   * @see ScheduleNow(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2>
-  static EventId ScheduleNow (MEM mem_ptr, OBJ obj, T1 a1, T2 a2);
-
-  /**
-   * @see ScheduleNow(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3>
-  static EventId ScheduleNow (MEM mem_ptr, OBJ obj, T1 a1, T2 a2, T3 a3);
-
-  /**
-   * @see ScheduleNow(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @tparam T4 @deduced Type of fourth argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @param [in] a4 The fourth argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4>
-  static EventId ScheduleNow (MEM mem_ptr, OBJ obj, 
-                              T1 a1, T2 a2, T3 a3, T4 a4);
-  /**
-   * @see ScheduleNow(MEM,OBJ)
-   * @tparam MEM @deduced Class method function signature type.
-   * @tparam OBJ @deduced Class type of the object.
-   * @tparam T1 @deduced Type of first argument.
-   * @tparam T2 @deduced Type of second argument.
-   * @tparam T3 @deduced Type of third argument.
-   * @tparam T4 @deduced Type of fourth argument.
-   * @tparam T5 @deduced Type of fifth argument.
-   * @param [in] mem_ptr Member method pointer to invoke
-   * @param [in] obj The object on which to invoke the member method
-   * @param [in] a1 The first argument to pass to the invoked method
-   * @param [in] a2 The second argument to pass to the invoked method
-   * @param [in] a3 The third argument to pass to the invoked method
-   * @param [in] a4 The fourth argument to pass to the invoked method
-   * @param [in] a5 The fifth argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4, typename T5>
-  static EventId ScheduleNow (MEM mem_ptr, OBJ obj, 
-                              T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
-
-  /**
-   * @param mem_ptr member method pointer to invoke
-   * @param obj the object on which to invoke the member method
-   * @param a1 the first argument to pass to the invoked method
-   * @param a2 the second argument to pass to the invoked method
-   * @param a3 the third argument to pass to the invoked method
-   * @param a4 the fourth argument to pass to the invoked method
-   * @param a5 the fifth argument to pass to the invoked method
-   * @param a6 the sixth argument to pass to the invoked method
-   * @return The EventId of the scheduled event.
-   */
-  template <typename MEM, typename OBJ, 
-            typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-  static EventId ScheduleNow (MEM mem_ptr, OBJ obj, 
-                              T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
-
-  /**
-   * @copybrief ScheduleNow(MEM,OBJ)
+   * We leverage SFINAE to discard this overload if the second argument is
+   * convertible to Ptr<EventImpl> or is a function pointer.
    *
-   * When the event expires (when it becomes due to be run), the
-   * function will be invoked with any supplied arguments.
-   * @param [in] f The function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  static EventId ScheduleNow (void (*f)(void));
-
-  /**
-   * @see ScheduleNow(*)
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1,
-            typename T1>
-  static EventId ScheduleNow (void (*f)(U1), T1 a1);
-
-  /**
-   * @see ScheduleNow(*)
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1, typename U2,
-            typename T1, typename T2>
-  static EventId ScheduleNow (void (*f)(U1,U2), T1 a1, T2 a2);
-
-  /**
-   * @see ScheduleNow(*)
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1, typename U2, typename U3,
-            typename T1, typename T2, typename T3>
-  static EventId ScheduleNow (void (*f)(U1,U2,U3), T1 a1, T2 a2, T3 a3);
-
-  /**
-   * @see ScheduleNow(*)
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam U4 @deduced Formal type of the fourth argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @tparam T4 @deduced Actual type of the fourth argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @param [in] a4 The fourth argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1, typename U2, typename U3, typename U4,
-            typename T1, typename T2, typename T3, typename T4>
-  static EventId ScheduleNow (void (*f)(U1,U2,U3,U4), T1 a1, T2 a2, T3 a3, T4 a4);
-
-  /**
-   * @see ScheduleNow(*)
-   * @tparam U1 @deduced Formal type of the first argument to the function.
-   * @tparam U2 @deduced Formal type of the second argument to the function.
-   * @tparam U3 @deduced Formal type of the third argument to the function.
-   * @tparam U4 @deduced Formal type of the fourth argument to the function.
-   * @tparam U5 @deduced Formal type of the fifth argument to the function.
-   * @tparam T1 @deduced Actual type of the first argument.
-   * @tparam T2 @deduced Actual type of the second argument.
-   * @tparam T3 @deduced Actual type of the third argument.
-   * @tparam T4 @deduced Actual type of the fourth argument.
-   * @tparam T5 @deduced Actual type of the fifth argument.
-   * @param [in] f The function to invoke
-   * @param [in] a1 The first argument to pass to the function to invoke
-   * @param [in] a2 The second argument to pass to the function to invoke
-   * @param [in] a3 The third argument to pass to the function to invoke
-   * @param [in] a4 The fourth argument to pass to the function to invoke
-   * @param [in] a5 The fifth argument to pass to the function to invoke
-   * @return The EventId of the scheduled event.
-   */
-  template <typename U1, typename U2, typename U3, typename U4, typename U5,
-            typename T1, typename T2, typename T3, typename T4, typename T5>
-  static EventId ScheduleNow (void (*f)(U1,U2,U3,U4,U5), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5);
+   * @tparam FUNC @deduced Template type for the function to invoke.
+   * @tparam Ts @deduced Actual function argument types.
+   * @param [in] f The function to invoke.
+   * @param [in] args Arguments to pass to the invoked function.
+   * @return The EventId of the scheduled event.
+   */
+  template <typename FUNC,
+            typename std::enable_if<!std::is_convertible<FUNC, Ptr<EventImpl>>::value,int>::type = 0,
+            typename std::enable_if<!std::is_function<typename std::remove_pointer<FUNC>::type>::value,int>::type = 0,
+            typename... Ts>
+  static EventId ScheduleNow (FUNC f, Ts&&... args);
 
   /**
-   * @param f the function to invoke
-   * @param a1 the first argument to pass to the function to invoke
-   * @param a2 the second argument to pass to the function to invoke
-   * @param a3 the third argument to pass to the function to invoke
-   * @param a4 the fourth argument to pass to the function to invoke
-   * @param a5 the fifth argument to pass to the function to invoke
-   * @param a6 the sixth argument to pass to the function to invoke
+   * Schedule an event to expire Now. All events scheduled to
+   * to expire "Now" are scheduled FIFO, after all normal events
+   * have expired.
+   *
+   * @tparam Us @deduced Formal function argument types.
+   * @tparam Ts @deduced Actual function argument types.
+   * @param [in] f The function to invoke.
+   * @param [in] args Arguments to pass to MakeEvent.
    * @return The EventId of the scheduled event.
    */
-  template <typename U1, typename U2, typename U3, typename U4, typename U5, typename U6,
-            typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
-  static EventId ScheduleNow (void (*f)(U1,U2,U3,U4,U5,U6), T1 a1, T2 a2, T3 a3, T4 a4, T5 a5, T6 a6);
+  template <typename... Us, typename... Ts>
+  static EventId ScheduleNow (void (*f)(Us...), Ts&&... args);
 
   /** @} */  // Schedule events (in the same context) to run now.
 
